//**************************************************************//
//  Effect File exported by RenderMonkey 1.6
//
//  - Although many improvements were made to RenderMonkey FX  
//    file export, there are still situations that may cause   
//    compilation problems once the file is exported, such as  
//    occasional naming conflicts for methods, since FX format 
//    does not support any notions of name spaces. You need to 
//    try to create workspaces in such a way as to minimize    
//    potential naming conflicts on export.                    
//    
//  - Note that to minimize resulting name collisions in the FX 
//    file, RenderMonkey will mangle names for passes, shaders  
//    and function names as necessary to reduce name conflicts. 
//**************************************************************//

//--------------------------------------------------------------//
// Lighting
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Pass 0
//--------------------------------------------------------------//
string Lighting_Pass_0_Model : ModelData = ".\\text.x";

struct VS_INPUT
{
   float4 pos : POSITION;
   float3 normal : NORMAL;
};

struct VS_OUTPUT
{
   float4 pos : POSITION;
   float3 diffuse : TEXCOORD1;
};

float4x4 gWorldMat : World;
float4x4 gViewMat : View;
float4x4 gProjMat : Projection;

float4 gWorldLightPosition
<
   string UIName = "gWorldLightPosition";
   string UIWidget = "Direction";
   bool UIVisible =  false;
   float4 UIMin = float4( -10.00, -10.00, -10.00, -10.00 );
   float4 UIMax = float4( 10.00, 10.00, 10.00, 10.00 );
   bool Normalize =  false;
> = float4( 500.00, 500.00, -500.00, 1.00 );

VS_OUTPUT Lighting_Pass_0_Vertex_Shader_vs_main(VS_INPUT input)
{
   VS_OUTPUT output;
   
   output.pos = mul(input.pos, gWorldMat);
   
   float3 lightDir = output.pos.xyz - gWorldLightPosition.xyz;
   lightDir = normalize(lightDir);
   
   output.pos = mul(output.pos, gViewMat);
   output.pos = mul(output.pos, gProjMat);
   
   float3 worldNormal = mul(input.normal, (float3x3)gWorldMat);
   worldNormal = normalize(worldNormal);
   
   output.diffuse = dot(-lightDir, worldNormal);
   
   return output;
}







struct PS_INPUT
{
   float3 diffuse : TEXCOORD1;
};

float4 Lighting_Pass_0_Pixel_Shader_ps_main(PS_INPUT input) : COLOR
{
   float3 diffuse = saturate(input.diffuse);
   return float4(diffuse, 1);
}
//--------------------------------------------------------------//
// Technique Section for Lighting
//--------------------------------------------------------------//
technique Lighting
{
   pass Pass_0
   {
      VertexShader = compile vs_2_0 Lighting_Pass_0_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 Lighting_Pass_0_Pixel_Shader_ps_main();
   }

}

